#DX Watch Dog

# Reads JSON file and constructs message.
# Looks for condition where the key "alerted" is false and the key "should alert" is true. This is a hit.
# Sends SMTP message via a secure SSL connection to cell phone carrier server.
# Copyright @2020 John Morphet, WØZI

import json #JSON built-in module
import smtplib, ssl #SMTP built-in module

#Variable Assignments
server = 'smtp.gmail.com'
port = 465                                  # 465 for SSL
password = 'password'                       #enter account password
sender_email = 'jdoe@gmail.com'         #enter account email address
receiver_email = '8185551212@vtext.com'     #enter cell_phone_number@carrier.com - https://freesmsgateway.info/

#Capture time stamp
from datetime import datetime
now = datetime.now()
current_time = now.strftime("%H:%M:%S")

#Construct message
message = ''
with open('cr-alert.json') as json_file:
    data = json.load(json_file)
    for callsign in data:
        if (data[callsign]['alerted']) == False and (data[callsign]['shouldAlert']) == True:    #Test for hit
            reLst = data[callsign]['reason']    #reLst is list class
            delimiter = ', '
            reval = delimiter.join(reLst)       #concatinates all elements in list and seperates with commas.
            reval = reval.upper()
            message = message + reval + ' from: ' + callsign + ', '+ data[callsign]['dxccName'] + '\n'
message = 'GridTracker Alert!' + '\n' + message + 'Current Time: ' + current_time


# Create a secure SSL context
context = ssl.create_default_context()

#Send message to SMTP server
with smtplib.SMTP_SSL(server, port, context=context) as server:
    server.login(sender_email, password)
    server.sendmail(sender_email, receiver_email, message)
